from math import hypot
import p_ggen

def plotdashdot(plotline, x, y, dash1, space1, dash2):
    "Plot polyline with dash1, space1, dash2, space2, ..."

    def plotdash(dashk, doplot):
        "Plot or move the length of one dash; if doplot is false move, else plot."
        nonlocal i, xnow, ynow, dnow
        if i >= len(d): return
        while dnow+dashk > d[i]:
            if doplot: plotline(xnow, ynow, x[i+1], y[i+1])
            xnow = x[i+1]
            ynow = y[i+1]
            dashk = dashk - (d[i]-dnow)
            i = i + 1
            if i >= len(d): return
            dnow = 0.0
        xd = xnow + dx[i] * dashk/d[i]
        yd = ynow + dy[i] * dashk/d[i]
        if doplot: plotline(xnow, ynow, xd, yd)
        xnow = xd
        ynow = yd
        dnow = dnow + dashk

    dx = [x2-x1 for x1,x2 in p_ggen.iterby2(x)]
    dy = [y2-y1 for y1,y2 in p_ggen.iterby2(y)]
    d = [hypot(dx1, dy1) for dx1,dy1 in zip(dx, dy)]
    xnow = x[1-1]
    ynow = y[1-1]
    dnow = 0.0
    i = 1-1
    while i < len(d):
        plotdash(dash1, True)
        plotdash(space1, False)
        plotdash(dash2, True)
        plotdash(space1, False)
